<?php
class CompilaCss 
{
    private $css = array();
 
    private $filemtime = 0;
    private $file      = '';
 
    public function addCss( $cssName )
    {
        $this->css[] = $cssName;
 
        // Soma todos as datas de alterações do arquivo
        // Aqui esta a mágica. Mudando algum CSS a soma dos filemtime serão
        // diferentes
        $this->filemtime += filemtime( $cssName );
    }
     
    public function linkCss( $base )
    {
        $this->file = 'site_cache/css_' . md5( $this->filemtime ) . '.css';
 
        if( !file_exists( $this->file ))
        {
            // Se o arquivo do CSS ainda não existir, cria outro. 
            // Basicamente se mudar algum filemtime de qualquer arquivo
            // um novo arquivo é criado
            $this->createCssFile();
        }
 
        echo '<link href="' . $base . $this->file . '" rel="stylesheet" type="text/css" />';
    }
     
    private function createCssFile()
    {
        $salvaCSS = '';
 
        foreach ( $this->css as $css )
        {
            // Pega o conteúdo dos arquivos CSS
            // adiciona todos os conteúdos a variável $salvaCSS
            $salvaCSS .= file_get_contents( $css );
        }
 
        // Retira todos os comentários
        $salvaCSS = preg_replace('!/\*.*?\*/!s', ' ', $salvaCSS);
        // Retira todos os espaços em branco e quebras de linhas
        $salvaCSS = preg_replace('/\s+/', ' ', $salvaCSS);
 
        // Salva
        file_put_contents( $this->file, $salvaCSS );
    }
}